All of lore.kernel.org
 help / color / mirror / Atom feed
* [PATCH v3] scripts: Create objdump-func helper script
@ 2022-04-20 17:16 Josh Poimboeuf
  2022-04-20 18:35 ` Borislav Petkov
  2022-04-21  8:52 ` Peter Zijlstra
  0 siblings, 2 replies; 5+ messages in thread
From: Josh Poimboeuf @ 2022-04-20 17:16 UTC (permalink / raw)
  To: Peter Zijlstra; +Cc: linux-kernel, x86, Miroslav Benes, Borislav Petkov

Add a simple script which disassembles a single function from an object
file.  Comes in handy for objtool warnings and kernel stack traces.

Originally-by: Peter Zijlstra <peterz@infradead.org>
Signed-off-by: Josh Poimboeuf <jpoimboe@redhat.com>
---
v3:
- Add usage
- Fix vmlinux

 scripts/objdump-func | 25 +++++++++++++++++++++++++
 1 file changed, 25 insertions(+)
 create mode 100755 scripts/objdump-func

diff --git a/scripts/objdump-func b/scripts/objdump-func
new file mode 100755
index 000000000000..0908f9f616c3
--- /dev/null
+++ b/scripts/objdump-func
@@ -0,0 +1,25 @@
+#!/bin/bash
+# SPDX-License-Identifier: GPL-2.0
+#
+# Disassemble a single function.
+#
+# usage: objdump-func <file> <func>
+
+set -o errexit
+set -o nounset
+
+OBJDUMP="${CROSS_COMPILE:-}objdump"
+
+command -v gawk >/dev/null 2>&1 || die "gawk isn't installed"
+
+usage() {
+	echo "usage: objdump-func <file> <func>" >&2
+	exit 1
+}
+
+[[ $# -ne 2 ]] && usage
+
+OBJ=$1; shift
+FUNC=$1; shift
+
+${OBJDUMP} -wdr $OBJ | gawk -M -v f=$FUNC '/^$/ { P=0; } $0 ~ "<" f ">:" { P=1; O=strtonum("0x" $1); } { if (P) { o=strtonum("0x" $1); printf("%04x ", o-O); print $0; } }'
-- 
2.34.1


^ permalink raw reply related	[flat|nested] 5+ messages in thread

end of thread, other threads:[~2022-04-21 20:40 UTC | newest]

Thread overview: 5+ messages (download: mbox.gz / follow: Atom feed)
-- links below jump to the message on this page --
2022-04-20 17:16 [PATCH v3] scripts: Create objdump-func helper script Josh Poimboeuf
2022-04-20 18:35 ` Borislav Petkov
2022-04-21  8:52 ` Peter Zijlstra
2022-04-21 17:37   ` Josh Poimboeuf
2022-04-21 20:39     ` Peter Zijlstra

This is an external index of several public inboxes,
see mirroring instructions on how to clone and mirror
all data and code used by this external index.